@use '../../../global/styles/styles-variables' as *;
@use '../../../global/styles/utilities' as *;
@use 'styles/calendar-week-view.variables' as *;

:host {
	@include digi-calendar-week-view--variables;
}

.digi-calendar-week-view__timepicker {
	display: flex;
	flex-wrap: wrap;
	justify-content: center;
}

.digi-calendar-week-view__week-button {
	--digi--ui--width--icon: var(--digi--calendar-week-view--button--week--icon--width);
	--digi--button--padding--medium: var(--digi--calendar-week-view--button--week--padding);
	--digi--button--display: var(--digi--calendar-week-view--button--week--display);
	--digi--button--width: var(--digi--calendar-week-view--button--week--width);
	--digi--button--justify-content: var(--digi--calendar-week-view--button--week--justify-content);
	--digi--button--color--background--secondary--default: var(--digi--calendar-week-view--button--week--background);
	--digi--button--color--background--secondary--hover: var(--digi--calendar-week-view--button--week--background);
	--digi--button--color--background--secondary--focus: var(--digi--calendar-week-view--button--week--background);
	--digi--button--color--background--secondary--active: var(--digi--calendar-week-view--button--week--background);
	--digi--button--color--border--secondary--hover: var(--digi--calendar-week-view--button--week--border-color);
	--digi--button--color--border--secondary--focus: var(--digi--calendar-week-view--button--week--border-color);
	--digi--button--color--border--secondary--active: var(--digi--calendar-week-view--button--week--border-color);
	--digi--button--font-size--medium: var(--digi--calendar-week-view--button--week--font-size);

	position: relative;

	&--previous {
		margin-right: var(--digi--calendar-week-view--button--week--margin);
		--digi--button--border-radius--secondary--default: var(--digi--calendar-week-view--button--week--previous-button--border-radius);
		--digi--button--border-radius--secondary--hover: var(--digi--calendar-week-view--button--week--previous-button--border-radius);
	}

	&--next {
		margin-left: var(--digi--calendar-week-view--button--week--margin);
		--digi--button--border-radius--secondary--default: var(--digi--calendar-week-view--button--week--next-button--border-radius);
		--digi--button--border-radius--secondary--hover: var(--digi--calendar-week-view--button--week--next-button--border-radius);
	}

	@media screen and (max-width: $digi--global--breakpoint--smallest-3) {
		--digi--calendar-week-view--button--week--width: var(--digi--calendar-week-view--button--week--width--small);
		--digi--calendar-week-view--button--week--margin: var(--digi--calendar-week-view--button--week--keep-right--margin--small);
	}

	&--keep-left,
	&--keep-right {
		--digi--calendar-week-view--button--week--margin: var(--digi--calendar-week-view--button--week--keep-right--margin);
	}

	&--hidden {
		display: none;
	}

	::slotted([slot^='icon']) {
		--digi--icon--width: var(--digi--calendar-week-view--button--icon--width);
	}
}

.digi-calendar-week-view__dates {
	flex: 1 0 100%;
	margin: var(--digi--calendar-week-view--dates--margin);
	display: flex;
	justify-content: center;
}

.digi-calendar-week-view__flex {
	display: flex;
	flex-direction: column;
	align-items: center;
}

.digi-calendar-week-view__heading {
	font-size: var(--digi--typography--body--font-size--desktop);
}

.digi-calendar-week-view__month {
	text-transform: capitalize;
}

.digi-calendar-week-view__date-list {
	list-style: none;
	display: grid;
	grid-template: repeat(1, 1fr) / repeat(5, var(--digi--calendar-week-view--button--date--width));
	grid-auto-flow: column;
	gap: var(--digi--calendar-week-view--dates--gap);
	margin: 0;
	padding: 0;

	@media screen and (max-width: $digi--global--breakpoint--smallest-3) {
		grid-template: repeat(1, 1fr) / repeat(5, var(--digi--calendar-week-view--button--date--width--small));
	}

	&-item {
		position: relative;
		margin: 0;
		padding: 0;
	}
}

.digi-calendar-week-view__date-button {
	--digi--button--width: 100%;
	--digi--button--border-radius--secondary--default: var(--digi--calendar-week-view--button--date--border-radius);
	--digi--button--border-radius--secondary--hover: var(--digi--calendar-week-view--button--date--border-radius);
	--digi--button--padding--medium: var(--digi--calendar-week-view--button--date--padding);
	--digi--button--font-size--medium: var(--digi--calendar-week-view--button--date--font-size);

	--digi--button--color--text--secondary--default: var(--digi--calendar-week-view--button--date--color);
	--digi--button--color--text--secondary--hover: var(--digi--calendar-week-view--button--date--color);
	--digi--button--color--text--secondary--focus: var(--digi--calendar-week-view--button--date--color);
	--digi--button--color--text--secondary--active: var(--digi--calendar-week-view--button--date--color);
	--digi--button--color--background--secondary--default: var(--digi--calendar-week-view--button--date--background);
	--digi--button--color--background--secondary--hover: var(--digi--calendar-week-view--button--date--background);
	--digi--button--color--background--secondary--focus: var(--digi--calendar-week-view--button--date--background);
	--digi--button--color--background--secondary--active: var(--digi--calendar-week-view--button--date--background);
	--digi--button--color--border--secondary--default: var(--digi--calendar-week-view--button--date--border-color);
	--digi--button--color--border--secondary--hover: var(--digi--calendar-week-view--button--date--border-color);
	--digi--button--color--border--secondary--focus: var(--digi--calendar-week-view--button--date--border-color);
	--digi--button--color--border--secondary--active: var(--digi--calendar-week-view--button--date--border-color);

	&--no-value {
		--digi--button--color--text--secondary--default: var(--digi--calendar-week-view--button--date--color--no-value);
		--digi--button--color--text--secondary--hover: var(--digi--calendar-week-view--button--date--color--no-value);
		--digi--button--color--text--secondary--focus: var(--digi--calendar-week-view--button--date--color--no-value);
		--digi--button--color--text--secondary--active: var(--digi--calendar-week-view--button--date--color--no-value);
		--digi--button--color--background--secondary--default: var(--digi--calendar-week-view--button--date--background--no-value);
		--digi--button--color--background--secondary--hover: var(--digi--calendar-week-view--button--date--background--no-value);
		--digi--button--color--background--secondary--focus: var(--digi--calendar-week-view--button--date--background--no-value);
		--digi--button--color--background--secondary--active: var(--digi--calendar-week-view--button--date--background--no-value);
		--digi--button--color--border--secondary--default: var(--digi--calendar-week-view--button--date--border-color--no-value);
		--digi--button--color--border--secondary--hover: var(--digi--calendar-week-view--button--date--border-color--no-value);
		--digi--button--color--border--secondary--focus: var(--digi--calendar-week-view--button--date--border-color--no-value);
		--digi--button--color--border--secondary--active: var(--digi--calendar-week-view--button--date--border-color--no-value);
		--digi--calendar-week-view--today-circle--background: var(--digi--calendar-week-view--today-circle--background--no-value);
	}

	&--active {
		--digi--button--color--text--secondary--default: var(--digi--calendar-week-view--button--date--color--active);
		--digi--button--color--text--secondary--hover: var(--digi--calendar-week-view--button--date--color--active);
		--digi--button--color--text--secondary--focus: var(--digi--calendar-week-view--button--date--color--active);
		--digi--button--color--text--secondary--active: var(--digi--calendar-week-view--button--date--color--active);
		--digi--button--color--background--secondary--default: var(--digi--calendar-week-view--button--date--background--active);
		--digi--button--color--background--secondary--hover: var(--digi--calendar-week-view--button--date--background--active);
		--digi--button--color--background--secondary--focus: var(--digi--calendar-week-view--button--date--background--active);
		--digi--button--color--background--secondary--active: var(--digi--calendar-week-view--button--date--background--active);
		--digi--button--color--border--secondary--default: var(--digi--calendar-week-view--button--date--border-color--active);
		--digi--button--color--border--secondary--hover: var(--digi--calendar-week-view--button--date--border-color--active);
		--digi--button--color--border--secondary--focus: var(--digi--calendar-week-view--button--date--border-color--active);
		--digi--button--color--border--secondary--active: var(--digi--calendar-week-view--button--date--border-color--active);
		--digi--calendar-week-view--today-circle--background: var(--digi--calendar-week-view--today-circle--background--active);
	}

	&-content {
		display: flex;
		flex-direction: column;
		align-items: center;
		justify-content: center;
		text-transform: capitalize;
	}
}

.digi-calendar-week-view__date-button-circle {
	position: absolute;
	height: var(--digi--calendar-week-view--today-circle--size);
	width: var(--digi--calendar-week-view--today-circle--size);
	background: var(--digi--calendar-week-view--today-circle--background);
	bottom: 0.875rem;
	left: 50%;
	transform: translateX(-50%);
	border-radius: 50%;
}

::slotted(* .digi-calendar-week-view__date-button--active .digi-button) {
	box-shadow: var(--digi--calendar-week-view--button--date--box-shadow--active);
}

::slotted(* .digi-calendar-week-view__date-button .digi-button) {
	&:hover,
	&:focus {
		.digi-calendar-week-view__date-button-day {
			&::after {
				content: '';
				position: absolute;
				width: 30px;
				height: 2px;
				top: 38px;
				background-color: var(--digi--calendar-week-view--button--date--color);
				left: 15px;
			}
			&--active {
				&::after {
					content: '';
					position: absolute;
					width: 30px;
					height: 2px;
					top: 38px;
					background-color: var(--digi--calendar-week-view--button--date--color--active);
					left: 15px;
				}
			}
		}
	}
}

::slotted(* .digi-calendar-week-view__date-button .digi-button__text) {
	width: 100%;
}

::slotted(* .digi-calendar-week-view__week-button--previous .digi-button) {
	&:hover,
	&:focus {
		&::after {
			content: '';
			position: absolute;
			width: 62px;
			height: 2px;
			top: 29px;
			background-color: #00005a;
			left: 57px;
		}
	}
}

::slotted(* .digi-calendar-week-view__week-button--next .digi-button) {
	&:hover,
	&:focus {
		&::after {
			content: '';
			position: absolute;
			width: 62px;
			height: 2px;
			top: 29px;
			background-color: #00005a;
			left: 38px;
		}
	}
}
